<?php
/* EZlogin
	author: team1/3
	name : ezlogin
	released: 2014/10/04
	coyright(c) SpiQe Software,team1/3 All Rights Reserved.
*/

	global $params, $html;

	define ( "EZLOGIN_ID", 141 );
	$html['article'][] = ezlogin_renderer($params['page']);
	

function ezlogin_renderer(&$page_ar)
{
	global $params, $ut, $html, $config, $database;

	if (!check_rights()) {
		@session_set_cookie_params(0, $config['site']['cookie_path']);
		@session_start();
	}
	load_proc('php','.plugin/ez_login/guest_uploader');
	
	if (!isset($html['css']['ezlogin_renderer'])) {
$html['css']['ezlogin_renderer'] = <<<EOT
		<style>
			.ezlogin-alert {
				padding:10px 20px;
				margin-bottom:20px;
				background-color: #FFFBCD;
			}

			.ezlogin-alert.onethird-setting td:nth-child(1) {
				text-align: right;
				padding-right: 1.5em;
				vertical-align: top;
				width: 10em;
			}

		</style>
EOT;
	}

	$buff = '';

	//マスターーデータの取得
	if (!isset($page_ar['meta']['ezlogin']) || !isset($page_ar['meta']['ezlogin']['master'])) {
		//マスターデータが無いので自分が親になる
		if (!isset($page_ar['meta']['ezlogin'])) {
			$page_ar['meta']['ezlogin'] = array();
		}
		$page_ar['meta']['ezlogin']['master'] = $page_ar['id'];
		$master_ar = $page_ar['meta']['ezlogin'];
		$master_ar['user'] = $page_ar['user'];
		if ($page_ar['link'] && read_pagedata( $page_ar['link'], $ar )) {
			if (isset($ar['meta']['ezlogin']['master'])) {
				if ($ar['meta']['ezlogin']['master']) {
					$page_ar['meta']['ezlogin']['master'] = $page_ar['link'];
					$master_ar = $ar['meta']['ezlogin'];
					$master_ar['user'] = $ar['user'];
				}
			}
		}
		if (mod_data_items($page_ar)) {
			$r['result'] = true;
		}

	} else {
		$master_ar = $page_ar['meta']['ezlogin'];
		$master_ar['user'] = $page_ar['user'];
		if ($page_ar['meta']['ezlogin']['master'] != $page_ar['id']) {
			//マスターデータの読み込み
			if (read_pagedata( $page_ar['meta']['ezlogin']['master'], $ar )) {
				$master_ar = $ar['meta']['ezlogin'];
				$master_ar['user'] = $ar['user'];
			}
		}
	}

	$master_id = $master_ar['master'];

	//アクセス権のチェック
	if (empty($_SESSION['ezlogin_id'])) {
		$member_ar = array();
		$master_id = $master_ar['master'];
		$sql = array();
		$sql[0] = "select id,date,metadata,user,status from ".DBX."user_log";
		$sql[1] = array(" where type=? and link=?",EZLOGIN_ID,$master_id);
		if (check_rights()) {
			$sql[2] = array(" and user=? ", $_SESSION['login_id']);
			$ar = $database->sql_select_all($sql);
			if (!$ar && check_rights()) {
				//ログインユーザーは全員書き込める
				$x = array();
				$x['link'] = $master_id;
				$x['type'] = EZLOGIN_ID;
				$x['status'] = 1;
				$x['metadata']['user_name'] = $params['login_user']['nickname'];

				if (add_user_log($x)) {
					$ar = $database->sql_select_all($sql);
					if (!$ar) {
						system_error( __FILE__, __LINE__ );
					}
					$_SESSION['ezlogin_name'] = $params['login_user']['nickname'];
					$_SESSION['ezlogin_id'] = $ar[0]['id'];
				}
			}
		} else {
			$ar = false;
			if (!empty($_GET['key'])) {
				$sql[2] = array(" and data=? ", sanitize_str($_GET['key']));
				$ar = $database->sql_select_all($sql);
				if ($ar && strtotime($ar[0]['date'])+60*60 > time()) {
					$x = array();
					$x['id'] = $ar[0]['id'];
					$x['status'] = 1;
					$x['data'] = '';
					$m = unserialize64($ar[0]['metadata']);
					if (mod_user_log($x)) {
						if ($x['meta']['ez_name']) {
							$_SESSION['ezlogin_name'] = $x['meta']['ez_name'];
						}
						$_SESSION['ezlogin_id'] = $ar[0]['id'];
						$_SESSION['ezlogin_idx'] = $x['meta']['ez_email'];

						$avatar = $config['site_ssl']."img/personal.png";
						if (check_rights()) {
							$avatar = $ut->safe_echo(get_user_image($ar[0]));
						}
						if (!empty($m['avatar'])) {
							$avatar = $ut->image_url('avatar/'.$m['avatar']);
						}
						$_SESSION['ezlogin_avatar'] = $avatar;

$html['meta']['ezlogin_ok']= <<<EOT
						<script>
							alert('ログインしました');
							location.href='{$ut->link($x['meta']['org_link'])}';
						</script>
EOT;
					}
				} else {
$buff .= <<<EOT
					<div class='ezlogin-alert onethird-setting'>
						<p>トークンの期限切れです
						</p>
					</div>
EOT;
				}
			}
			if (!$ar) {
				if (empty($master_ar['ezlogin']['hide_panel'])) {
$buff .= <<<EOT
					<div class='ezlogin-alert onethird-setting'>
						<p>このページをご利用いただくためには<a href='{$ut->link($master_id,'&:mode=login')}'>登録/ログイン</a>が必要です
						</p>
					</div>
EOT;
				}
			}
		}
	} else {
		if (empty($master_ar['ezlogin']['hide_panel'])) {
$buff .= <<<EOT
			<div class='ezlogin-alert onethird-setting'>
				<p>ログインしています <a href='{$ut->link($master_id,'&:mode=login')}' class='onethird-button mini'>設定</a>
				</p>
			</div>
EOT;
		}
	}
	
	if (isset($_GET['mode']) && ($_GET['mode']=='login' || $_GET['mode']=='new' || $_GET['mode']=='forget')) {
		$buff = ezlogin_panel($page_ar, $master_ar);
		$params['rendering'] = false;
	} else {
		if (check_rights('edit')) {
			if (isset($_GET['mode']) && $_GET['mode']=='member') {
				$params['breadcrumb'] = array(
					array( 'link'=>$page_ar['id'], 'text'=>$page_ar['title'] )
					, array( 'link'=>0, 'text'=>"Member setting" )
				);
				$buff = _ezlogin_page($page_ar,$member_ar,$master_ar);
				return frame_renderer($buff);
			}
$tmp = <<<EOT
			<a href='{$ut->link($page_ar['id'],'&:mode=member')}' >
			{$ut->icon('admin',array('title'=>"Members' page"))}</a>
EOT;
			$params['add-blockmenu'][] = $tmp;
		}
	}
	return frame_renderer($buff);
}

function _ezlogin_page( &$page_ar , &$member_ar , &$master_ar)
{
	global $database, $params, $ut, $html;

	$master_id = $master_ar['master'];
	$owner = (!isset($_SESSION['login_id']) || $page_ar['user'] == $_SESSION['login_id']);

	$buff = '';
	$r['setting'] = $page_ar['meta'];
	
	//if (!check_rights('edit') && !empty($params['edit-right'])) {
	//	set_func_rights('edit.modules');
	//	provide_edit_rights();
	//}

	$user_log = DBX."user_log";
	$users = DBX."users";
	$sql = "select $user_log.id as id, $user_log.date as date
		, $user_log.metadata as metadata
		, $users.name as name
		, $users.id as user
		, $users.nickname as nickname
		, $user_log.status as status
		from $user_log 
		left join $users on $users.id=$user_log.user
		where type=? and link=? order by date desc
		";
	$ar = $database->sql_select_all($sql, EZLOGIN_ID, $master_id);
	if (!$ar) {
		return 'error';
	} else {
		$is_owner = $master_ar['user'] == $_SESSION['login_id'];
$buff .= <<<EOT
		<h1>Access control</h1>
		<p>
			<a href='{$ut->link($page_ar['id'])}' class='onethird-button mini' >Exit</a>
EOT;
			if ($is_owner && $master_ar['master'] == $page_ar['id']) {
$buff .= <<<EOT
				<a href='javascript:void(ot.member_setting())' class='onethird-button mini'>Setting</a>
EOT;
			}
			
			if ($master_ar['master'] != $page_ar['id']) {
$buff .= <<<EOT
				<a href='{$ut->link($master_ar['master'],'&:mode=member')}'>master page setting</a>
EOT;
			}
			
$buff .= <<<EOT
		</p>
		<table class='onethird-table'>
			<tr>
				<th>date</th>
				<th>name</th>
				<th>status</th>
			</tr>
EOT;
			foreach ($ar as $v) {
				$m = unserialize64($v['metadata']);
				if ($v['status'] == 1) {
					$d = '';
				} else {
					$d = 'pending';

				}
				if ($v['nickname']) {
					$v['name'] = $v['nickname']." ";
				}
				if (!empty($m['ez_name'])) {
					$v['name'] .= $m['ez_name'];
				}
				if (!empty($m['ez_email'])) {
					$v['name'] .= " ({$m['ez_email']})";
				}
				$avatar = '';
				if (!empty($m['avatar'])) {
					$avatar = "<img src='{$ut->image_url('avatar/'.$m['avatar'])}' style='width:32px' />";
				}
$buff .= <<<EOT
				<tr>
					<td>{$v['date']}</td>
					<td>$avatar {$v['name']}</td>
					<td>$d 
						
EOT;
						if ($master_ar['master'] == $page_ar['id'] && $owner) {
$buff .= <<<EOT
							<a href='javascript:void(ot.del_member_page_list_member({$v['id']}))'>
								{$ut->icon('delete')}
							</a>
EOT;
						}
$buff .= <<<EOT
					</td>
				</tr>
EOT;

			}
$buff .= <<<EOT
		</table>
EOT;
	}

	if ($master_ar['master'] == $page_ar['id']) {
		if (check_rights('edit')) {
			snippet_std_setting("Setting","member_setting");
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == "member_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $master_id = $master_ar['master'];
			$r['meta'] = $page_ar['meta'];
$r['html'] = <<<EOT
			<table>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label><input type='checkbox' data-input='share_member' {$ut->check(!empty($r['meta']['ezlogin']['share_member']),'checked')}/> share member data</label></li>
							<li><label><input type='checkbox' data-input='hide_panel' {$ut->check(!empty($r['meta']['ezlogin']['hide_panel']),'checked')}/> Hide login panel</label></li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_member_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $page_ar['id'];
			$r['meta'] = $page_ar['meta'];
			$r['meta']['ezlogin'] = array();
			if (isset($_POST['share_member'])) { $r['meta']['ezlogin']['share_member'] = true; } else { unset($r['meta']['ezlogin']['share_member']); }
			if (isset($_POST['hide_panel'])) { $r['meta']['ezlogin']['hide_panel'] = true; } else { unset($r['meta']['ezlogin']['hide_panel']); }
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}

$tmp = <<<EOT
		<script>
			ot.del_member_page_list_member = function(idx) {
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: "ajax=del_member_page_list_member&idx="+idx
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							location.reload(true);
						}
					}
				});
			};
		</script>
EOT;
		$html['meta']['member_page_list_member'] = $tmp;

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'del_member_page_list_member')  {
			$r = array();
			$r['result'] = false;
			if (!isset($_SESSION['login_id']) || $master_ar['user'] == $_SESSION['login_id']) {
				$r['idx'] = (int)$_POST['idx'];
				$r['result'] = $database->sql_update("delete from ".DBX."user_log where type=? and id=?", EZLOGIN_ID, $r['idx']);
			}
			echo(json_encode($r));
			exit();
		}
	}
	$params['rendering'] = false;
	$html['article'] = array(frame_renderer($buff));
	return '';
}

function ezlogin_panel(&$page_ar, &$master_ar)
{
	global $html,$database,$params,$config,$ut;

	
	$buff = '';
	$mode = sanitize_asc($_GET['mode']);

	if (!empty($_SESSION['ezlogin_id'])) {
		if (!check_rights('edit')) {
			$opt = array();
			$opt['uploader_resize'] = array(array(48,48,1));
			$opt['group'] = "avatar";
			$opt['remove'] = false;
			if (function_exists('guest_uploader')) {
				guest_uploader($opt);
			}
		}
$buff .= <<<EOT
		<h1>簡易ログイン(設定)</h1>
		<div class='onethird-setting'>
			<input type='hidden' value='{$_SESSION['ezlogin_idx']}' id='ez_idx' /></td>
			<table >
				<tr>
					<td>ユーザー名</td>
					<td><input type='text' value='{$_SESSION['ezlogin_name']}' id='ez_name' /></td>
				</tr>
				<tr>
					<td>メールアドレス</td>
					<td><input type='email' value='{$_SESSION['ezlogin_idx']}' id='ez_email' /></td>
				</tr>
				<tr>
					<td>パスワード</td>
					<td><input type='password' value='' id='ez_pass' /></td>
				</tr>
EOT;
				if (function_exists('guest_uploader')) {
					if ($_SESSION['ezlogin_avatar']) {
						$avatar = $_SESSION['ezlogin_avatar'];
					} else {
						$avatar = $config['site_ssl']."img/personal.png";
					}
$buff .= <<<EOT
					<tr>
						<td>avatar</td>
						<td>
							<div style='background-color: #c0c0c0;padding:1px;display: inline-block;'>
								<img id='user_avatar' name='user_avatar' src='{$avatar}' onclick='ot.open_uploader({group:"avatar",resize:"auto",select:function(obj){ot.set_avatar(obj)}})' style='cursor:pointer; $style' /> 
							</div>
						</td>
					</tr>
EOT;
				}
$buff .= <<<EOT
				<tr>
					<td></td>
					<td>
						<input type='button' value='Update' class='onethird-button' onclick='ot.plugin_ezlogin_login("setting")' />
						<input type='button' value='Logout' class='onethird-button mini' onclick='ot.plugin_ezlogin_logout()' />
						<a href='{$ut->link($master_ar['master'])}' class='onethird-button mini' >戻る</a>
					</td>
				</tr>
			</table>
		</div>
EOT;
	} else if ($mode == 'new') {
$buff .= <<<EOT
		<h1>簡易ログイン(新規登録)</h1>
		<p>
			メールアドレスとパスワードを入力してください
		</p>
		<div class='onethird-setting'>
			<table >
				<tr>
					<td>ユーザー名</td>
					<td><input type='text' value='' id='ez_name' /></td>
				</tr>
				<tr>
					<td>メールアドレス</td>
					<td><input type='email' value='' id='ez_email' /></td>
				</tr>
				<tr>
					<td>パスワード</td>
					<td><input type='password' value='' id='ez_pass' /></td>
				</tr>
				<tr>
					<td></td>
					<td>
						<input type='button' value='新規登録' class='onethird-button' onclick='ot.plugin_ezlogin_login("new")' />
						<a href='{$ut->link($master_ar['master'],'&:mode=login')}'>戻る</a>
					</td>
				</tr>
			</table>
		</div>
EOT;
	} else if ($mode == 'forget') {
$buff .= <<<EOT
		<h1>簡易ログイン</h1>
		<p>
			パスワードをリセットします
		</p>
		<p>
			登録時のメールアドレスを入力してください
		</p>
		<div class='onethird-setting'>
			<table >
				<tr>
					<td>メールアドレス</td>
					<td><input type='email' value='' id='ez_email' /></td>
				</tr>
				<tr>
					<td></td>
					<td>
						<input type='button' value='送信' class='onethird-button' onclick='ot.plugin_ezlogin_login("forget")' />
						<a href='{$ut->link($master_ar['master'],'&:mode=login')}'>戻る</a>
					</td>
				</tr>
			</table>
		</div>
EOT;
	} else {
$buff .= <<<EOT
		<h1>簡易ログイン</h1>
		<p>
			すでに登録済みの方は、メールアドレスとパスワードを入力してください
		</p>
		<p>
			新規登録の方は<a href='{$ut->link($master_ar['master'],'&:mode=new')}'>こちら</a>
		</p>
		<p>
			パスワードを忘れた方は<a href='{$ut->link($master_ar['master'],'&:mode=forget')}'>こちら</a>
		</p>
		<div class='onethird-setting'>
			<table >
				<tr>
					<td>メールアドレス</td>
					<td><input type='email' value='' id='ez_email' /></td>
				</tr>
				<tr>
					<td>パスワード</td>
					<td><input type='password' value='' id='ez_pass' /></td>
				</tr>
				<tr>
					<td></td>
					<td>
						<input type='button' value='ログイン' class='onethird-button' onclick='ot.plugin_ezlogin_login("login")' />
					</td>
				</tr>
			</table>
		</div>
EOT;
	}

$tmp = <<<EOT
<script>
	
	ot.plugin_ezlogin_logout = function(mode) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=*plugin_ezlogin_logout"
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					alert('ログアウトしました');
					location.reload(true);
				}
			}
		});
	};
	ot.plugin_ezlogin_login = function(mode) {
		var a ='';
		var t = '';
		if (\$('#ez_name').length) {
			t = \$('#ez_name').val();
			if (!t) {
				alert('ユーザー名を入力してください');
				return;
			}
			a += '&ez_name='+encodeURIComponent(t);
		}
		
		if (\$('#ez_idx').length) {
			t = \$('#ez_idx').val();
			a += '&ez_idx='+encodeURIComponent(t);
		}
		t = \$('#ez_email').val();
		if (!t) {
			alert('メールアドレスを入力してください');
			return;
		}
		a += '&ez_email='+encodeURIComponent(t);
		
		if (\$('#ez_pass').length) {
			t = \$('#ez_pass').val();
			if (!t) {
				if (mode != 'setting') {
					alert('パスワードを入力してください');
					return;
				}
			} else {
				a += '&ez_pass='+encodeURIComponent(t);
			}
		}
		if (\$('#user_avatar').length) {
			var b = \$('#user_avatar').attr('data-src');
			a += '&avatar='+encodeURIComponent(b);
		}
		a += '&mode='+encodeURIComponent(mode);
		
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=*plugin_ezlogin_login"+a
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					if (data['mode']=='login') {
						if (data['mess']) { alert(data['mess']); }
						location.href=data['url'];
					} else {
						alert(data['mess']);
					}
				} else {
					var m = 'ログインできません';
					if (data['mess']) { m = data['mess']; }
					alert(m);
				}
			}
		});
	};
	ot.plugin_ezlogin_click = function(mode) {
		ot.ajax({
			type: "POST"
			, url: '{$_SERVER['REQUEST_URI']}'
			, data: "ajax=*plugin_ezlogin_click&mode="+mode
			, dataType:'json'
			, success: function(data){
				if ( data && data['html'] ) {
					\$('#ezlogin-panel').html(data['html']);
				}
			}
		});
	};
	ot.set_avatar = function(obj) {
		var a = \$(obj).parent().attr('data-src');
		if (a) {
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: "ajax=*set_avatar&src="+encodeURIComponent(a)
				, dataType:'json'
				, success: function(data){
					if ( data && data['src'] ) {
						\$('#user_avatar').attr('src',data['src']).attr('data-src',data['data']);
						ot.close_dialog();
					} else {
						alert('error');
					}
				}
			});
		}
	};
</script>
EOT;
	$html['meta']['ezlogin_panel'] = $tmp;

	if (isset($_POST['ajax']) && $_POST['ajax'] == '*set_avatar')  {
		$r = array();
		$r['result'] = false;
		if (!empty($_SESSION['ezlogin_id'])) {
			$x = array();
			$x['id'] = (int)$_SESSION['ezlogin_id'];
			$x['meta']['avatar'] = sanitize_asc($_POST['src']); 
			if (mod_user_log($x)) {
				$r['result'] = true;
				$r['src'] = $ut->image_url('avatar/'.$x['meta']['avatar']);
				$r['data'] = $x['meta']['avatar'];
			}
		}
		echo(json_encode($r));
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == '*plugin_ezlogin_logout')  {
		$r = array();
		$r['result'] = true;
		unset($_SESSION['ezlogin_id']);
		echo(json_encode($r));
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == '*plugin_ezlogin_login')  {
		$r = array();
		$r['result'] = false;
		if (!empty($_SESSION['login_id'])) {
			$r['user_id'] = $_SESSION['login_id'];
		} else {
			$r['user_id'] = 0;
		}
		$mode = sanitize_asc($_POST['mode']);
		$r['mode'] = $mode;
		$r['mess'] = '';
		if (check_rights() || empty($_POST['mode'])) {
			echo(json_encode($r));
			exit();
		}

		$ez_name = $ez_email = $ez_pass = false;
		if (!empty($_POST['ez_name'])) { $ez_name = sanitize_asc($_POST['ez_name']); }
		if (!empty($_POST['ez_email'])) { $ez_email = sanitize_asc($_POST['ez_email']); }
		if (!empty($_POST['ez_idx'])) { $ez_email = sanitize_asc($_POST['ez_idx']); }
		if (!empty($_POST['ez_pass'])) { $ez_pass = sanitize_asc($_POST['ez_pass']); }
		
		$master_id = $master_ar['master'];
		if ($mode=='new') {
			if (!$ez_name || !$ez_email || !$ez_pass) {
				$r['mess'] = '設定エラー';
				echo(json_encode($r));
				exit();
			}
		} else if ($mode=='forget') {
			if (!$ez_email) {
				echo(json_encode($r));
				exit();
			}
			if (!empty($master_ar['share_member'])) {
				$ar = $database->sql_select_all("select id,date,metadata,user,status from ".DBX."user_log where type=? and att=? order by id desc", EZLOGIN_ID, $ez_email);
			} else {
				$ar = $database->sql_select_all("select id,date,metadata,user,status from ".DBX."user_log where type=? and att=? and link=? ", EZLOGIN_ID, $ez_email, $master_id);
			}
			if ($ar) {
				$r['mess'] = 'パスワードリセットメールを送りました';
				$ar[0]['data'] = $params['magic_number'];
				$ar[0]['date'] = $params['now'];
				mod_user_log($ar[0]);
				$r['url'] = $ut->link($page_ar['id'],'&:key='.$ar[0]['data']);
				echo(json_encode($r));
				exit();
			}
		} else if ($mode=='setting') {
			if (!$ez_email || !$ez_name) {
				$r['mess'] = '設定エラー';
				echo(json_encode($r));
				exit();
			}
		} else {
			//login
			if (!$ez_email || !$ez_pass) {
				echo(json_encode($r));
				exit();
			}
		}
		if (!empty($master_ar['share_member'])) {
			$ar = $database->sql_select_all("select id,date,metadata,user,status from ".DBX."user_log where type=? and att=? order by id desc", EZLOGIN_ID, $ez_email);
		} else {
			$ar = $database->sql_select_all("select id,date,metadata,user,status from ".DBX."user_log where type=? and att=? and link=? ", EZLOGIN_ID, $ez_email, $master_id);
		}
		if ($ar) {
			if ($mode=='new') {
				$r['result'] = false;
				$r['mess'] = "すでに登録されています";
				echo(json_encode($r));
				exit();
			}
			if ($mode=='setting') {
				$r['mess'] = "変更しました";
				$ar[0]['att'] = $ez_email;
				$ar[0]['meta'] = unserialize64($ar[0]['metadata']);
				if ($ez_email != sanitize_asc($_POST['ez_email'])) {
					$n = sanitize_asc($_POST['ez_email']);
					if (!empty($master_ar['share_member'])) {
						$ar2 = $database->sql_select_all("select id from ".DBX."user_log where type=? and att=? and link=? order by id desc", EZLOGIN_ID, $n);
					} else {
						$ar2 = $database->sql_select_all("select id from ".DBX."user_log where type=? and att=? and link=? ", EZLOGIN_ID, $n, $master_id);
					}
					if (!$ar2) {
						$_SESSION['ezlogin_idx'] = $ar[0]['meta']['ez_email'] = sanitize_asc($_POST['ez_email']);
					} else {
						$r['mess'] = "メールアドレスの重複";
						echo(json_encode($r));
						exit();
					}
				}
				$_SESSION['ezlogin_name'] = $ar[0]['meta']['ez_name'] = $ez_name;
				if ($ez_pass) {
					$ar[0]['meta']['ez_pass'] = hash('sha1',$ez_pass);
				}
				if (!empty($_POST['avatar'])) {
					$ar[0]['meta']['avatar'] = sanitize_asc($_POST['avatar']);
					$_SESSION['ezlogin_avatar'] = $ut->image_url('avatar/'.$ar[0]['meta']['avatar']);
				} else {
					unset($ar[0]['meta']['avatar']);
				}
				$ar[0]['metadata'] = serialize64($ar[0]['meta']);
				$r['result'] = mod_user_log($ar[0]);
				echo(json_encode($r));
				exit();
			}
			$m = unserialize64($ar[0]['metadata']);
			if (!empty($m['ez_pass'])) {
				if ($m['ez_pass'] == hash('sha1',$ez_pass)) {
					$_SESSION['ezlogin_name'] = $m['ez_name'];
					$_SESSION['ezlogin_id'] = $ar[0]['id'];
					$_SESSION['ezlogin_idx'] = $m['ez_email'];
					
					$avatar = $config['site_ssl']."img/personal.png";
					if (check_rights()) {
						$avatar = $ut->safe_echo(get_user_image($ar[0]));
					}
					if (!empty($m['avatar'])) {
						$avatar = $ut->image_url('avatar/'.$m['avatar']);
					}
					$_SESSION['ezlogin_avatar'] = $avatar;

					$r['url'] = $ut->link($m['org_link']);
					$ar[0]['date'] = $params['now'];
					mod_user_log($ar[0]);
					$r['mess'] = 'ログインしました';
					$r['result'] = true;
				}
			}
			echo(json_encode($r));
			exit();

		} else {
			if ($mode=='new') {
				$x = array();
				$x['link'] = $master_id;
				$x['type'] = EZLOGIN_ID;
				$x['status'] = 0;
				$x['meta']['ez_name'] = $ez_name;
				$x['data'] = $params['magic_number'];
				$x['meta']['org_link'] = $page_ar['id'];
				$x['att'] = $x['meta']['ez_email'] = $ez_email;
				$x['meta']['ez_pass'] = hash('sha1',$ez_pass);
				if (add_user_log($x)) {
					$r['id'] = $x['id'];
					$r['mess'] = '登録メールを送りました';
					$r['result'] = true;
					$r['url'] = $ut->link($page_ar['id'],'&:key='.$x['data']);
				}
			}
		}
		echo(json_encode($r));
		exit();
	}
	return $buff;
}


?>